class BIORHYTHM
creation
	make
feature
	num_days1,num_days2:INTEGER				-- var for save the birth_date and current_date
	days:INTEGER							-- total number of days
	date_now:STRING							-- current date
	num_critical_day:INTEGER				-- the number of critical day
	physical_cycle:INTEGER is 23			-- constant for physical cycle
	emotional_cycle:INTEGER is 28			-- constant for emotional cycle
	intellectual_cycle:INTEGER is 33		-- constant for intellectual cycle

	make is
	local
		positive_days:BOOLEAN		-- DOB must be less or equal than current date.
		again:BOOLEAN				-- want to repeat again?
	do
		from
			ask_birth_date
			again:=true
		until 
			not again
		loop
			from
				ask_date
				days:=num_days2-num_days1
				positive_days:=days>=0
			until
				positive_days
			loop
				io.putstring("%NYou Haven't Born At That Date.%N")
				io.putstring("Please Try Again.%N%N")
				ask_date
				days:=num_days2-num_days1
				positive_days:=days>=0
			end -- loop

			io.putstring("%NOn the ")
			io.putstring(date_now)
			io.putstring(", you will have been alive for ")
			io.putint(days)
			if days>1 then
				io.putstring(" days.")
			else
				io.putstring(" day.")
			end -- if

			physical(days)
			emotional(days)
			intellectual(days)
			check_critical(num_critical_day)
			again:=run_again
		end -- loop
	end -- make		

	ask_birth_date is
	-- ask user for the birth date
	local
 		temp_date:DATE_STRING_TO_DATE
		temp_date_string:STRING
		temp_num_days:CONVERT_TO_DAYS
		correct_date:BOOLEAN
	do
		io.putstring("Not Dave's Fantastic Biorhythm Program%N")

		from
		until
			correct_date			-- repeat if the date is not valid.
		loop
			io.putstring("Please enter your date of birth : ")
			io.read_line
			temp_date_string:=io.laststring
			!!temp_date.make(temp_date_string)
			if temp_date.is_valid then
				!!temp_num_days.make(temp_date.date,temp_date.month,temp_date.year)
				if temp_num_days.is_exist then
					num_days1:=temp_num_days.get_days
					correct_date:=true
				else
					io.putstring("%NThe date doesn't exist!!!%N")
				end -- if
			else
				io.putstring("%NWrong Date!!!%N")
			end -- if
			if not correct_date then
				io.putstring("Write The Date In Format dd/mm/yyyy%N")
				io.putstring("Example : Please enter your date of birth : 18/10/1943%N%N")
			end -- if
		end -- loop
	end -- ask_birth_date

	ask_date is
	-- ask user for the date he want to check his biorhythm.
	local
 		temp_date:DATE_STRING_TO_DATE
		temp_date_string:STRING
		temp_num_days:CONVERT_TO_DAYS
		correct_date:BOOLEAN
	do
		from
		until
			correct_date			-- repeat if the date is not valid.
		loop
			io.putstring("Please enter the date you are interested in : ")
			io.read_line
			temp_date_string:=io.laststring
			!!temp_date.make(temp_date_string)
			if temp_date.is_valid then
				!!temp_num_days.make(temp_date.date,temp_date.month,temp_date.year)
				if temp_num_days.is_exist then
					num_days2:=temp_num_days.get_days
					correct_date:=true
				else
					io.putstring("%NThe date doesn't exist!!!%N")
				end -- if
			else
				io.putstring("%NWrong Date!!!%N")
			end -- if
			if not correct_date then
				io.putstring("Write The Date In Format dd/mm/yyyy%N")
				io.putstring("Example : Please enter the date you are interested in : 1/1/2000%N%N")
			end -- if
		end -- loop
		date_now:=temp_date_string
	end -- ask_date

	physical(d:INTEGER)is
	-- check for the physical cycle
	local
		temp_days:INTEGER
	do
		temp_days:=d\\physical_cycle
		io.putstring("%NYou are ")
		io.putint(temp_days)
		if temp_days>1 then
			io.putstring(" days")
		else
			io.putstring(" day")
		end -- if
		io.putstring(" into your physical cycle. ")
		if temp_days>0 and temp_days<(physical_cycle//2) then
			io.putstring("This cycle is ascending.")
		elseif temp_days>(physical_cycle//2) and temp_days<(physical_cycle)then
			io.putstring("This cycle is descending.")
		else
			io.putstring("This is a critical day.")
			num_critical_day:=num_critical_day+1
		end -- if
		io.new_line
	end -- physical

	emotional(d:INTEGER)is
	-- check for the emotional cycle
	local
		temp_days:INTEGER
	do
		temp_days:=d\\emotional_cycle
		io.putstring("You are ")
		io.putint(temp_days)
		if temp_days>1 then
			io.putstring(" days")
		else
			io.putstring(" day")
		end -- if
		io.putstring(" into your emotional cycle. ")
		if temp_days>0 and temp_days<(emotional_cycle//2) then
			io.putstring("This cycle is ascending.")
		elseif temp_days>(emotional_cycle//2) and temp_days<(emotional_cycle)then
			io.putstring("This cycle is descending.")
		else
			io.putstring("This is a critical day.")
			num_critical_day:=num_critical_day+1
		end -- if
		io.new_line
	end -- emotional

	intellectual(d:INTEGER)is
	-- check for the intellectual cycle
	local
		temp_days:INTEGER
	do
		temp_days:=d\\intellectual_cycle
		io.putstring("You are ")
		io.putint(temp_days)
		if temp_days>1 then
			io.putstring(" days")
		else
			io.putstring(" day")
		end -- if
		io.putstring(" into your intellectual cycle. ")
		if temp_days>0 and temp_days<(intellectual_cycle//2) then
			io.putstring("This cycle is ascending.")
		elseif temp_days>(intellectual_cycle//2) and temp_days<(intellectual_cycle)then
			io.putstring("This cycle is descending.")
		else
			io.putstring("This is a critical day.")
			num_critical_day:=num_critical_day+1
		end -- if
		io.new_line
	end -- intellectual

	check_critical(n:INTEGER) is
	-- check for the number of critical day.
	do
		inspect n
			when 2 then io.putstring("You have Double Critical Days.%N")
			when 3 then io.putstring("You have Triple Critical Days.%N")
			else			-- do nothing
		end -- inspect
	end -- check_critical

	run_again:BOOLEAN is
	-- ask user if he wants to check for another date or not.
	local
		ch:character
		s_temp:STRING
	do
		from
		until
			ch='Y' or ch='y' or ch='N' or ch='n'
		loop
			io.putstring("%NWould you like to know your biorhythms for another date? ")
			io.read_line
			s_temp:=io.laststring
			if not s_temp.empty then
				ch:=s_temp.item(1)
			end -- if
			inspect ch
				when 'y', 'Y' then
					Result:=true
				when 'n', 'N' then
				else
					io.putstring("Wrong Input!!! Please Try Again.")
			end -- inspect
			io.new_line
		end -- loop
	end -- run_again
end -- BIORHYTHM
