class CONVERT_TO_DAYS
creation
	make
feature
	date, month, year:INTEGER
	days_a_year:INTEGER is 365		-- number of days in normal year

	make(d,m,y:integer) is
	do
		date:=d
		month:=m
		year:=y
	end -- make

	is_exist:BOOLEAN is
	-- is the date exist and the number of days is less than 2^30-1.
	-- 2^30-1 is the maximum number of integer.
	do
		if year>=0 and year<(2147483647//366)then
			if month>=1 and month<=12 then
				if date>=1 and date<=month_to_days(month,is_leap_year(year)) then
					Result:=true
				end -- if
			end -- if
		end -- if

	end -- is_exist

	is_leap_year(y:INTEGER):BOOLEAN is
	-- is the 'y' year is a leap year?
	do
		if (y\\100)/=0 then
			if (y\\4)=0 then
				Result:=true
			end -- if
		else
			if (y\\400)=0 then
				Result:=true
			end -- if
		end -- if
	end -- is_leap_year

	get_days:INTEGER is
	-- get the total number of days.
	do
		Result:=get_days_from_year(year-1)+get_days_from_month(month-1,is_leap_year(year))+date
	end -- get_days

	get_days_from_year(y:INTEGER):INTEGER is
	-- get the number of days from the years.
	local
		temp_days:INTEGER
	do
		if y>0 then
			temp_days:=days_a_year*y		-- LEAP YEAR:
			temp_days:=temp_days+(y//4)		-- Years divisible by four are leap years, unless...
			temp_days:=temp_days-(y//100)		-- Years also divisible by 100 are not leap years, except...
			temp_days:=temp_days+(y//400)		-- Years divisible by 400 are leap years.
		end -- if
		Result:=temp_days
	end -- get_num_days_from_year

	get_days_from_month(m:INTEGER;ly:BOOLEAN):INTEGER is
	-- get the number of days from the months.
	local
		temp_days:INTEGER
		temp_month:INTEGER
	do
		from
			temp_month:=m
		until 
			temp_month<1
		loop
			temp_days:=temp_days+month_to_days(temp_month,ly)
			temp_month:=temp_month-1
		end -- loop
		Result:=temp_days
	end -- get_days_from_month

	month_to_days(m:INTEGER;ly:BOOLEAN):INTEGER is
	-- get the number days from current month
	require
		valid_month: (m>=1 and m<=12)
	do
		inspect m
			when 1,3,5,7,8,10,12 then Result:=31
			when 4,6,9,11 then Result:=30
			when 2 then 	if ly then
						Result:=29
					else
						Result:=28
					end -- if
			else		-- do nothing
		end -- inspect
	end -- month_to_days
end -- CONVERT_TO_DAYS